class SetChannelMemberInfo {
  SetChannelMemberInfo({
    required this.channelID,
    required this.userID,
    this.roleLevel,
    this.nickname,
    this.faceURL,
    this.ex,
  });

  final String channelID;
  final String userID;
  final int? roleLevel;
  final String? nickname;
  final String? faceURL;
  final String? ex;

  SetChannelMemberInfo.fromJson(Map<String, dynamic> json)
      : channelID = json['channelID'],
        userID = json['userID'],
        roleLevel = json['roleLevel'],
        nickname = json['nickname'],
        faceURL = json['faceURL'],
        ex = json['ex'];

  Map<String, dynamic> toJson() {
    final data = Map<String, dynamic>();
    data['channelID'] = channelID;
    data['userID'] = userID;
    data['roleLevel'] = roleLevel;
    data['nickname'] = nickname;
    data['faceURL'] = faceURL;
    data['ex'] = ex;
    return data;
  }

  @override
  String toString() {
    return 'SetChannelMemberInfo{channelID: $channelID, userID: $userID, roleLevel: $roleLevel, nickname: $nickname, faceURL: $faceURL, ex: $ex}';
  }
}
